-- vim:tabstop=3:shiftwidth=3
--
-- Table structure for rate engine Least Cost [call] Routing (LCR)
--
-- To import, simply type 'source schema.sql' from the mysql prompt.
--
-- To use this with postgresql, all I beleive should be necessary is to change
-- the 'auto_increment'
--

--
-- Table structure for table `rate_engine_cdr`
--

CREATE TABLE rate_engine_cdr (
	cdr_id integer primary key auto_increment,
	callDate datetime NOT NULL,
	endDate datetime NOT NULL,
	ANI varchar(80) NOT NULL,
	callerID varchar(80),
	calledNumber varchar(80) NOT NULL,
	calledContext varchar(80) NOT NULL,
	sourceChannel varchar(80) NOT NULL,
	destinationChannel varchar(80) NOT NULL,
	lastApplication varchar(80) NOT NULL,
	lastData varchar(80),
	callDuration integer NOT NULL,
	billableDuration integer NOT NULL,
	callDisposition varchar(16),
	amaFlags varchar(16),
	accountCode varchar(20),
	destinationDescription varchar(80),
	callCost float,
	callCostCurrency char(3) references rate_engine_currency(currency_id),
	uniqueID varchar(32) NOT NULL,
	handlingSystem varchar(32)
);

--
-- Table structure for table `rate_engine_egress`
--

CREATE TABLE rate_engine_egress (
	route_id integer primary key auto_increment,
	provider_id integer NOT NULL references rate_engine_provider(provider_id),
	technology varchar(16) NOT NULL,
	peer varchar(32) NOT NULL,
	pattern varchar(80) default '.*',
	substitute varchar(80) NOT NULL,
	description varchar(80)
);

--
-- Table structure for table `rate_engine_currency`
--

CREATE TABLE rate_engine_currency (
	currency_id char(3) primary key,
	price float not null
);

--
-- Table structure for table `rate_engine_provider`
--

CREATE TABLE rate_engine_provider (
	provider_id integer primary key auto_increment,
	name varchar(80) NOT NULL,
	currency char(3) NOT NULL references rate_engine_currency(currency_id)
);

--
-- Table structure for table `rate_engine_rate`
--

CREATE TABLE rate_engine_rate (
	rate_id integer primary key auto_increment,
	route_id integer NOT NULL references rate_engine_egress(route_id),
	iso varchar(2) NOT NULL,
	type varchar(3),
	country varchar(40) NOT NULL,
	extra varchar(40),
	prefix varchar(10) NOT NULL,
	active_date date,
	expires_date date,
	firstperiod integer NOT NULL,
	periods integer NOT NULL,
	startcost float,
	periodcost float,
	trialcost float,
);

--
-- Indicies for `rate_engine_rate`
--
create index re_route_id_idx on rate_engine_rate(route_id);
create index re_prefix_idx on rate_engine_rate(prefix);

